<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OrderSearchData StructType
 * @subpackage Structs
 */
class OrderSearchData extends AbstractStructBase
{
    /**
     * The id
     * @var int
     */
    public $id;
    /**
     * The productId
     * @var int
     */
    public $productId;
    /**
     * The deliveryFeeType
     * @var int
     */
    public $deliveryFeeType;
    /**
     * The productSellerCode
     * @var string
     */
    public $productSellerCode;
    /**
     * The status
     * @var string
     */
    public $status;
    /**
     * The rejectReason
     * @var string
     */
    public $rejectReason;
    /**
     * The approvedDate
     * @var string
     */
    public $approvedDate;
    /**
     * The dueAmount
     * @var float
     */
    public $dueAmount;
    /**
     * The installmentChargeWithVAT
     * @var float
     */
    public $installmentChargeWithVAT;
    /**
     * The price
     * @var float
     */
    public $price;
    /**
     * The totalMallDiscountPrice
     * @var float
     */
    public $totalMallDiscountPrice;
    /**
     * The quantity
     * @var int
     */
    public $quantity;
    /**
     * The sellerCouponDiscount
     * @var float
     */
    public $sellerCouponDiscount;
    /**
     * The sellerStockCode
     * @var string
     */
    public $sellerStockCode;
    /**
     * The version
     * @var int
     */
    public $version;
    /**
     * The attributes
     * @var \StructType\SkuAttributeList
     */
    public $attributes;
    /**
     * The sellerDiscount
     * @var float
     */
    public $sellerDiscount;
    /**
     * The mallDiscount
     * @var float
     */
    public $mallDiscount;
    /**
     * The commission
     * @var float
     */
    public $commission;
    /**
     * The sellerInvoiceAmount
     * @var float
     */
    public $sellerInvoiceAmount;
    /**
     * The productName
     * @var string
     */
    public $productName;
    /**
     * The shipmentInfo
     * @var \StructType\OrderItemShipmentInfo
     */
    public $shipmentInfo;
    /**
     * The shippingDate
     * @var string
     */
    public $shippingDate;
    /**
     * The customTextOptionValues
     * @var \StructType\CustomTextOptionsDataList
     */
    public $customTextOptionValues;
    /**
     * The shipmenCompanyCampaignNumber
     * @var string
     */
    public $shipmenCompanyCampaignNumber;
    /**
     * Constructor method for OrderSearchData
     * @uses OrderSearchData::setId()
     * @uses OrderSearchData::setProductId()
     * @uses OrderSearchData::setDeliveryFeeType()
     * @uses OrderSearchData::setProductSellerCode()
     * @uses OrderSearchData::setStatus()
     * @uses OrderSearchData::setRejectReason()
     * @uses OrderSearchData::setApprovedDate()
     * @uses OrderSearchData::setDueAmount()
     * @uses OrderSearchData::setInstallmentChargeWithVAT()
     * @uses OrderSearchData::setPrice()
     * @uses OrderSearchData::setTotalMallDiscountPrice()
     * @uses OrderSearchData::setQuantity()
     * @uses OrderSearchData::setSellerCouponDiscount()
     * @uses OrderSearchData::setSellerStockCode()
     * @uses OrderSearchData::setVersion()
     * @uses OrderSearchData::setAttributes()
     * @uses OrderSearchData::setSellerDiscount()
     * @uses OrderSearchData::setMallDiscount()
     * @uses OrderSearchData::setCommission()
     * @uses OrderSearchData::setSellerInvoiceAmount()
     * @uses OrderSearchData::setProductName()
     * @uses OrderSearchData::setShipmentInfo()
     * @uses OrderSearchData::setShippingDate()
     * @uses OrderSearchData::setCustomTextOptionValues()
     * @uses OrderSearchData::setShipmenCompanyCampaignNumber()
     * @param int $id
     * @param int $productId
     * @param int $deliveryFeeType
     * @param string $productSellerCode
     * @param string $status
     * @param string $rejectReason
     * @param string $approvedDate
     * @param float $dueAmount
     * @param float $installmentChargeWithVAT
     * @param float $price
     * @param float $totalMallDiscountPrice
     * @param int $quantity
     * @param float $sellerCouponDiscount
     * @param string $sellerStockCode
     * @param int $version
     * @param \StructType\SkuAttributeList $attributes
     * @param float $sellerDiscount
     * @param float $mallDiscount
     * @param float $commission
     * @param float $sellerInvoiceAmount
     * @param string $productName
     * @param \StructType\OrderItemShipmentInfo $shipmentInfo
     * @param string $shippingDate
     * @param \StructType\CustomTextOptionsDataList $customTextOptionValues
     * @param string $shipmenCompanyCampaignNumber
     */
    public function __construct($id = null, $productId = null, $deliveryFeeType = null, $productSellerCode = null, $status = null, $rejectReason = null, $approvedDate = null, $dueAmount = null, $installmentChargeWithVAT = null, $price = null, $totalMallDiscountPrice = null, $quantity = null, $sellerCouponDiscount = null, $sellerStockCode = null, $version = null, \StructType\SkuAttributeList $attributes = null, $sellerDiscount = null, $mallDiscount = null, $commission = null, $sellerInvoiceAmount = null, $productName = null, \StructType\OrderItemShipmentInfo $shipmentInfo = null, $shippingDate = null, \StructType\CustomTextOptionsDataList $customTextOptionValues = null, $shipmenCompanyCampaignNumber = null)
    {
        $this
            ->setId($id)
            ->setProductId($productId)
            ->setDeliveryFeeType($deliveryFeeType)
            ->setProductSellerCode($productSellerCode)
            ->setStatus($status)
            ->setRejectReason($rejectReason)
            ->setApprovedDate($approvedDate)
            ->setDueAmount($dueAmount)
            ->setInstallmentChargeWithVAT($installmentChargeWithVAT)
            ->setPrice($price)
            ->setTotalMallDiscountPrice($totalMallDiscountPrice)
            ->setQuantity($quantity)
            ->setSellerCouponDiscount($sellerCouponDiscount)
            ->setSellerStockCode($sellerStockCode)
            ->setVersion($version)
            ->setAttributes($attributes)
            ->setSellerDiscount($sellerDiscount)
            ->setMallDiscount($mallDiscount)
            ->setCommission($commission)
            ->setSellerInvoiceAmount($sellerInvoiceAmount)
            ->setProductName($productName)
            ->setShipmentInfo($shipmentInfo)
            ->setShippingDate($shippingDate)
            ->setCustomTextOptionValues($customTextOptionValues)
            ->setShipmenCompanyCampaignNumber($shipmenCompanyCampaignNumber);
    }
    /**
     * Get id value
     * @return int|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param int $id
     * @return \StructType\OrderSearchData
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !is_numeric($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get productId value
     * @return int|null
     */
    public function getProductId()
    {
        return $this->productId;
    }
    /**
     * Set productId value
     * @param int $productId
     * @return \StructType\OrderSearchData
     */
    public function setProductId($productId = null)
    {
        // validation for constraint: int
        if (!is_null($productId) && !is_numeric($productId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($productId)), __LINE__);
        }
        $this->productId = $productId;
        return $this;
    }
    /**
     * Get deliveryFeeType value
     * @return int|null
     */
    public function getDeliveryFeeType()
    {
        return $this->deliveryFeeType;
    }
    /**
     * Set deliveryFeeType value
     * @param int $deliveryFeeType
     * @return \StructType\OrderSearchData
     */
    public function setDeliveryFeeType($deliveryFeeType = null)
    {
        // validation for constraint: int
        if (!is_null($deliveryFeeType) && !is_numeric($deliveryFeeType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($deliveryFeeType)), __LINE__);
        }
        $this->deliveryFeeType = $deliveryFeeType;
        return $this;
    }
    /**
     * Get productSellerCode value
     * @return string|null
     */
    public function getProductSellerCode()
    {
        return $this->productSellerCode;
    }
    /**
     * Set productSellerCode value
     * @param string $productSellerCode
     * @return \StructType\OrderSearchData
     */
    public function setProductSellerCode($productSellerCode = null)
    {
        // validation for constraint: string
        if (!is_null($productSellerCode) && !is_string($productSellerCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($productSellerCode)), __LINE__);
        }
        $this->productSellerCode = $productSellerCode;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\OrderSearchData
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get rejectReason value
     * @return string|null
     */
    public function getRejectReason()
    {
        return $this->rejectReason;
    }
    /**
     * Set rejectReason value
     * @param string $rejectReason
     * @return \StructType\OrderSearchData
     */
    public function setRejectReason($rejectReason = null)
    {
        // validation for constraint: string
        if (!is_null($rejectReason) && !is_string($rejectReason)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rejectReason)), __LINE__);
        }
        $this->rejectReason = $rejectReason;
        return $this;
    }
    /**
     * Get approvedDate value
     * @return string|null
     */
    public function getApprovedDate()
    {
        return $this->approvedDate;
    }
    /**
     * Set approvedDate value
     * @param string $approvedDate
     * @return \StructType\OrderSearchData
     */
    public function setApprovedDate($approvedDate = null)
    {
        // validation for constraint: string
        if (!is_null($approvedDate) && !is_string($approvedDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($approvedDate)), __LINE__);
        }
        $this->approvedDate = $approvedDate;
        return $this;
    }
    /**
     * Get dueAmount value
     * @return float|null
     */
    public function getDueAmount()
    {
        return $this->dueAmount;
    }
    /**
     * Set dueAmount value
     * @param float $dueAmount
     * @return \StructType\OrderSearchData
     */
    public function setDueAmount($dueAmount = null)
    {
        $this->dueAmount = $dueAmount;
        return $this;
    }
    /**
     * Get installmentChargeWithVAT value
     * @return float|null
     */
    public function getInstallmentChargeWithVAT()
    {
        return $this->installmentChargeWithVAT;
    }
    /**
     * Set installmentChargeWithVAT value
     * @param float $installmentChargeWithVAT
     * @return \StructType\OrderSearchData
     */
    public function setInstallmentChargeWithVAT($installmentChargeWithVAT = null)
    {
        $this->installmentChargeWithVAT = $installmentChargeWithVAT;
        return $this;
    }
    /**
     * Get price value
     * @return float|null
     */
    public function getPrice()
    {
        return $this->price;
    }
    /**
     * Set price value
     * @param float $price
     * @return \StructType\OrderSearchData
     */
    public function setPrice($price = null)
    {
        $this->price = $price;
        return $this;
    }
    /**
     * Get totalMallDiscountPrice value
     * @return float|null
     */
    public function getTotalMallDiscountPrice()
    {
        return $this->totalMallDiscountPrice;
    }
    /**
     * Set totalMallDiscountPrice value
     * @param float $totalMallDiscountPrice
     * @return \StructType\OrderSearchData
     */
    public function setTotalMallDiscountPrice($totalMallDiscountPrice = null)
    {
        $this->totalMallDiscountPrice = $totalMallDiscountPrice;
        return $this;
    }
    /**
     * Get quantity value
     * @return int|null
     */
    public function getQuantity()
    {
        return $this->quantity;
    }
    /**
     * Set quantity value
     * @param int $quantity
     * @return \StructType\OrderSearchData
     */
    public function setQuantity($quantity = null)
    {
        // validation for constraint: int
        if (!is_null($quantity) && !is_numeric($quantity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($quantity)), __LINE__);
        }
        $this->quantity = $quantity;
        return $this;
    }
    /**
     * Get sellerCouponDiscount value
     * @return float|null
     */
    public function getSellerCouponDiscount()
    {
        return $this->sellerCouponDiscount;
    }
    /**
     * Set sellerCouponDiscount value
     * @param float $sellerCouponDiscount
     * @return \StructType\OrderSearchData
     */
    public function setSellerCouponDiscount($sellerCouponDiscount = null)
    {
        $this->sellerCouponDiscount = $sellerCouponDiscount;
        return $this;
    }
    /**
     * Get sellerStockCode value
     * @return string|null
     */
    public function getSellerStockCode()
    {
        return $this->sellerStockCode;
    }
    /**
     * Set sellerStockCode value
     * @param string $sellerStockCode
     * @return \StructType\OrderSearchData
     */
    public function setSellerStockCode($sellerStockCode = null)
    {
        // validation for constraint: string
        if (!is_null($sellerStockCode) && !is_string($sellerStockCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sellerStockCode)), __LINE__);
        }
        $this->sellerStockCode = $sellerStockCode;
        return $this;
    }
    /**
     * Get version value
     * @return int|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param int $version
     * @return \StructType\OrderSearchData
     */
    public function setVersion($version = null)
    {
        // validation for constraint: int
        if (!is_null($version) && !is_numeric($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
    /**
     * Get attributes value
     * @return \StructType\SkuAttributeList|null
     */
    public function getAttributes()
    {
        return $this->attributes;
    }
    /**
     * Set attributes value
     * @param \StructType\SkuAttributeList $attributes
     * @return \StructType\OrderSearchData
     */
    public function setAttributes(\StructType\SkuAttributeList $attributes = null)
    {
        $this->attributes = $attributes;
        return $this;
    }
    /**
     * Get sellerDiscount value
     * @return float|null
     */
    public function getSellerDiscount()
    {
        return $this->sellerDiscount;
    }
    /**
     * Set sellerDiscount value
     * @param float $sellerDiscount
     * @return \StructType\OrderSearchData
     */
    public function setSellerDiscount($sellerDiscount = null)
    {
        $this->sellerDiscount = $sellerDiscount;
        return $this;
    }
    /**
     * Get mallDiscount value
     * @return float|null
     */
    public function getMallDiscount()
    {
        return $this->mallDiscount;
    }
    /**
     * Set mallDiscount value
     * @param float $mallDiscount
     * @return \StructType\OrderSearchData
     */
    public function setMallDiscount($mallDiscount = null)
    {
        $this->mallDiscount = $mallDiscount;
        return $this;
    }
    /**
     * Get commission value
     * @return float|null
     */
    public function getCommission()
    {
        return $this->commission;
    }
    /**
     * Set commission value
     * @param float $commission
     * @return \StructType\OrderSearchData
     */
    public function setCommission($commission = null)
    {
        $this->commission = $commission;
        return $this;
    }
    /**
     * Get sellerInvoiceAmount value
     * @return float|null
     */
    public function getSellerInvoiceAmount()
    {
        return $this->sellerInvoiceAmount;
    }
    /**
     * Set sellerInvoiceAmount value
     * @param float $sellerInvoiceAmount
     * @return \StructType\OrderSearchData
     */
    public function setSellerInvoiceAmount($sellerInvoiceAmount = null)
    {
        $this->sellerInvoiceAmount = $sellerInvoiceAmount;
        return $this;
    }
    /**
     * Get productName value
     * @return string|null
     */
    public function getProductName()
    {
        return $this->productName;
    }
    /**
     * Set productName value
     * @param string $productName
     * @return \StructType\OrderSearchData
     */
    public function setProductName($productName = null)
    {
        // validation for constraint: string
        if (!is_null($productName) && !is_string($productName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($productName)), __LINE__);
        }
        $this->productName = $productName;
        return $this;
    }
    /**
     * Get shipmentInfo value
     * @return \StructType\OrderItemShipmentInfo|null
     */
    public function getShipmentInfo()
    {
        return $this->shipmentInfo;
    }
    /**
     * Set shipmentInfo value
     * @param \StructType\OrderItemShipmentInfo $shipmentInfo
     * @return \StructType\OrderSearchData
     */
    public function setShipmentInfo(\StructType\OrderItemShipmentInfo $shipmentInfo = null)
    {
        $this->shipmentInfo = $shipmentInfo;
        return $this;
    }
    /**
     * Get shippingDate value
     * @return string|null
     */
    public function getShippingDate()
    {
        return $this->shippingDate;
    }
    /**
     * Set shippingDate value
     * @param string $shippingDate
     * @return \StructType\OrderSearchData
     */
    public function setShippingDate($shippingDate = null)
    {
        // validation for constraint: string
        if (!is_null($shippingDate) && !is_string($shippingDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($shippingDate)), __LINE__);
        }
        $this->shippingDate = $shippingDate;
        return $this;
    }
    /**
     * Get customTextOptionValues value
     * @return \StructType\CustomTextOptionsDataList|null
     */
    public function getCustomTextOptionValues()
    {
        return $this->customTextOptionValues;
    }
    /**
     * Set customTextOptionValues value
     * @param \StructType\CustomTextOptionsDataList $customTextOptionValues
     * @return \StructType\OrderSearchData
     */
    public function setCustomTextOptionValues(\StructType\CustomTextOptionsDataList $customTextOptionValues = null)
    {
        $this->customTextOptionValues = $customTextOptionValues;
        return $this;
    }
    /**
     * Get shipmenCompanyCampaignNumber value
     * @return string|null
     */
    public function getShipmenCompanyCampaignNumber()
    {
        return $this->shipmenCompanyCampaignNumber;
    }
    /**
     * Set shipmenCompanyCampaignNumber value
     * @param string $shipmenCompanyCampaignNumber
     * @return \StructType\OrderSearchData
     */
    public function setShipmenCompanyCampaignNumber($shipmenCompanyCampaignNumber = null)
    {
        // validation for constraint: string
        if (!is_null($shipmenCompanyCampaignNumber) && !is_string($shipmenCompanyCampaignNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($shipmenCompanyCampaignNumber)), __LINE__);
        }
        $this->shipmenCompanyCampaignNumber = $shipmenCompanyCampaignNumber;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OrderSearchData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
